﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace Z11
{
    class Program //Nefunguje to
    {
        private static List<FileInfo> soubory = new List<FileInfo>();
        private static bool pouzivanaZakladniCesta = false;

        static void Main(string[] args)
        {
            string cesta = "";

            try
            {
                cesta = args[0];
            }
            catch (Exception e)
            {
#if DEBUG
                cesta = @"C:\Users\Jakub\Desktop\vzorova_zadani";
                pouzivanaZakladniCesta = true;
#endif
                Console.WriteLine("CHYBA: " + e.Message + "\nPokud jsme v DEBUG MODE -> cesta je zvolena na vzorova_zadani");
            }
            Console.WriteLine(cesta);
            SkenujSlozku(cesta);

            Console.WriteLine(soubory.Count.ToString());
            Console.WriteLine("Zacinam s resenim a zapisovanim: \n\n\n");

            foreach (FileInfo soubor in soubory)
            {
                Console.WriteLine("Nova vez...");

                Vez vez = new Vez(soubor);
                vez.PostavAUlozVez();
            }

            Console.ReadKey(true);
        }

        private static void SkenujSlozku(string cesta)
        {
            DirectoryInfo slozka = new DirectoryInfo(cesta);

            soubory.AddRange(slozka.EnumerateFiles("*.in", SearchOption.TopDirectoryOnly));
            soubory.Sort((x, y) => string.Compare(x.Name, y.Name));
        }
    }

    class Vez
    {
        public enum TypVeze
        {
            P,
            D,
            PB,
            DB
        }

        public int X { get; private set; }
        public int Y { get; private set; }
        public TypVeze Typ { get; private set; }
        public List<Kostka> SoucetDostupnychKostkek { get; private set; }
        public Dictionary<Kostka, int> KostekZbyva { get; private set; }
        private FileInfo Soubor;

        public int CelkemKostekZbyva
        {
            get
            {
                int soucet = 0;

                foreach (KeyValuePair<Kostka, int> par in KostekZbyva)
                {
                    soucet += par.Value;
                }

                return soucet;
            }
        }

        public Vez(FileInfo Soubor)
        {
            SoucetDostupnychKostkek = new List<Kostka>();
            KostekZbyva = new Dictionary<Kostka, int>();
            this.Soubor = Soubor;

            StreamReader reader = Soubor.OpenText();
            string text = reader.ReadToEnd();
            string[] radky = text.Split(new string[] { Environment.NewLine }, StringSplitOptions.RemoveEmptyEntries);

            string[] prvniRadek = radky[0].Split(new string[] { " " }, StringSplitOptions.RemoveEmptyEntries);
            X = Int32.Parse(prvniRadek[0]);
            Y = Int32.Parse(prvniRadek[1]);
            NastavTyp(prvniRadek[2]);

            radky[0] = "";

            foreach (string radek in radky)
            {
                if (radek == "")
                    continue;

                SoucetDostupnychKostkek.Add(new Kostka(radek));
            }

            foreach (Kostka kostka in SoucetDostupnychKostkek)
            {
                KostekZbyva.Add(kostka, kostka.Pocet);
            }

        }

        private void NastavTyp(string typ)
        {
            switch (typ)
            {
                case "P":
                    this.Typ = TypVeze.P;
                    break;
                case "D":
                    this.Typ = TypVeze.D;
                    break;
                case "PB":
                    this.Typ = TypVeze.PB;
                    break;
                case "DB":
                    this.Typ = TypVeze.DB;
                    break;
            }
        }
        private string ZiskejTyp()
        {
            switch (Typ)
            {
                case TypVeze.P:
                    return "P";
                case TypVeze.D:
                    return "D";
                case TypVeze.PB:
                    return "PB";
                case TypVeze.DB:
                    return "DB";
                default:
                    return null;
            }
        }

        public void PostavAUlozVez()
        {
            string jmeno = Soubor.Directory.FullName + @"\" + Soubor.Name;
            jmeno = jmeno.Substring(0, jmeno.Count() - 3);
            jmeno = jmeno + ".11";
            Console.WriteLine(jmeno);
            StreamWriter writer = new StreamWriter(jmeno);

            string prvniRadek = X.ToString() + " " + Y.ToString() + " " + ZiskejTyp();
            writer.WriteLine(prvniRadek);

            if (Typ == TypVeze.P)
            {
                while (CelkemKostekZbyva > X * Y)
                {
                    string patro = PostavPlnePatro();
                    writer.Write(patro);
                }
            }

            writer.Close();
            return;
        }

        private string PostavPlnePatro() //Bohuzel nemam ani tuseni, jak to udelat
        {
            return "";
        }
    }

    class Kostka
    {
        public Barva BarvaKostky { get; private set; }
        public Rozmer RozmerKostky { get; private set; }
        public int Pocet { get; private set; }

        public Kostka(string text)
        {
            string[] pole = text.Split(new string[] { " " }, StringSplitOptions.RemoveEmptyEntries);

            BarvaKostky = Barva.VyberBarvu(pole[0][0]);
            RozmerKostky = pole[1];
            Pocet = Int32.Parse(pole[2]);
        }
    }

    class Barva : IEquatable<Barva>
    {
        public char Kod { get; private set; }
        public string Nazev { get; private set; }
        public string RGB { get; private set; }

        public static List<Barva> Barvy = new List<Barva>
        {
            new Barva('A', "azurova", "0, 255, 255"),
            new Barva('R', "cervena", "255, 0, 0"),
            new Barva('G', "zelena", "0, 255, 0"),
            new Barva('B', "modra", "0, 0, 255"),
            new Barva('Y', "zluta", "255, 255, 0")
        };

        public Barva(char Kod, string Nazev, string RGB)
        {
            this.Kod = Kod;
            this.Nazev = Nazev;
            this.RGB = RGB;
        }

        public static Barva VyberBarvu(char c)
        {
            return (from b in Barvy
                   where b.Kod == c
                   select b).First();

        }
    
        public bool Equals(Barva other)
        {
            if (other == null)
                return false;

            if (this.Kod == other.Kod)
                return true;

            return false;
        }
    }

    class Rozmer
    {
        public int X { get; private set; }
        public int Y { get; private set; }

        public Rozmer(string text)
        {
            X = text[0];
            Y = text[2];
        }

        public static implicit operator Rozmer(string text)
        {
            return new Rozmer(text);
        }
    }
}
